/*   $OSSEC, config.c, v0.2, 2005/01/17, Daniel B. Cid$   */

/* Copyright (C) 2004,2005 Daniel B. Cid <dcid@ossec.net>
 * All right reserved.
 *
 * This program is a free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "headers/defs.h"
#include "headers/os_err.h"

#include "headers/file_op.h"
#include "headers/config_op.h"
#include "headers/debug_op.h"
#include "os_xml/os_xml.h"
#include "os_regex/os_regex.h"
#include "os_net/os_net.h"

#include "logcollector.h"
extern short int dbg_flag;


/* FilesConf v0.3, 2005/03/03
 * Read the config file (the localfiles)
 * v0.3: Changed for the new OS_XML
 */
int FilesConf(char * cfgfile,logreader *logr)
{
    unsigned int i=0,j=0;
    OS_XML xml;

    /* XML Definitions */
    char *(xml_localfile_location[])={xml_localfile,"location",NULL};
    char *(xml_localfile_group[])={xml_localfile, "group",NULL};

    if(OS_ReadXML(cfgfile,&xml) < 0)
    {
        merror("config_op: XML error: %s",xml.err);
        return(OS_INVALID);
    }

    if(!OS_RootElementExist(&xml,xml_localfile))
    {
        OS_ClearXML(&xml);
        return(OS_NOTFOUND);
    }

    logr->file = OS_GetElementContent(&xml, xml_localfile_location);	
    if(logr->file == NULL)
    {
        OS_ClearXML(&xml);	
        return(OS_NOTFOUND);
    }

    for(i=0;;i++)
        if(logr->file[i] == NULL)
            break;

    if(i == 0)
    {
        merror("config_op: No file configured to be read");
        OS_ClearXML(&xml);
        return(OS_INVALID);
    }

    logr->group = OS_GetElementContent(&xml, xml_localfile_group);
    for(j=0;;j++)
    {
        if(logr->group[j] == NULL)
            break;
    }

    if(i != j)
    {
        char *_tmpstr="logreader: Each file must have an associated";
        merror("config_op: %s group. Config Error.",_tmpstr);
        OS_ClearXML(&xml);
        return(OS_INVALID);
    }

    OS_ClearXML(&xml);
    return(j);
}
